<?php

return CRM_Core_CodeGen_SqlData::create('civicrm_relationship_type')
  ->addValues([
    [
      'name_a_b' => 'Child of',
      'label_a_b' => ts('Child of'),
      'name_b_a' => 'Parent of',
      'label_b_a' => ts('Parent of'),
      'description' => ts('Parent/child relationship.'),
      'contact_type_a' => 'Individual',
      'contact_type_b' => 'Individual',
      'is_reserved' => 0,
    ],
    [
      'name_a_b' => 'Spouse of',
      'label_a_b' => ts('Spouse of'),
      'name_b_a' => 'Spouse of',
      'label_b_a' => ts('Spouse of'),
      'description' => ts('Spousal relationship.'),
      'contact_type_a' => 'Individual',
      'contact_type_b' => 'Individual',
      'is_reserved' => 0,
    ],
    [
      'name_a_b' => 'Partner of',
      'label_a_b' => ts('Partner of'),
      'name_b_a' => 'Partner of',
      'label_b_a' => ts('Partner of'),
      'description' => ts('Partner relationship.'),
      'contact_type_a' => 'Individual',
      'contact_type_b' => 'Individual',
      'is_reserved' => 0,
    ],
    [
      'name_a_b' => 'Sibling of',
      'label_a_b' => ts('Sibling of'),
      'name_b_a' => 'Sibling of',
      'label_b_a' => ts('Sibling of'),
      'description' => ts('Sibling relationship.'),
      'contact_type_a' => 'Individual',
      'contact_type_b' => 'Individual',
      'is_reserved' => 0,
    ],
    [
      'name_a_b' => 'Employee of',
      'label_a_b' => ts('Employee of'),
      'name_b_a' => 'Employer of',
      'label_b_a' => ts('Employer of'),
      'description' => ts('Employment relationship.'),
      'contact_type_a' => 'Individual',
      'contact_type_b' => 'Organization',
      'is_reserved' => 1,
    ],
    [
      'name_a_b' => 'Volunteer for',
      'label_a_b' => ts('Volunteer for'),
      'name_b_a' => 'Volunteer is',
      'label_b_a' => ts('Volunteer is'),
      'description' => ts('Volunteer relationship.'),
      'contact_type_a' => 'Individual',
      'contact_type_b' => 'Organization',
      'is_reserved' => 0,
    ],
    [
      'name_a_b' => 'Head of Household for',
      'label_a_b' => ts('Head of Household for'),
      'name_b_a' => 'Head of Household is',
      'label_b_a' => ts('Head of Household is'),
      'description' => ts('Head of household.'),
      'contact_type_a' => 'Individual',
      'contact_type_b' => 'Household',
      'is_reserved' => 1,
    ],
    [
      'name_a_b' => 'Household Member of',
      'label_a_b' => ts('Household Member of'),
      'name_b_a' => 'Household Member is',
      'label_b_a' => ts('Household Member is'),
      'description' => ts('Household membership.'),
      'contact_type_a' => 'Individual',
      'contact_type_b' => 'Household',
      'is_reserved' => 1,
    ],
    [
      'name_a_b' => 'Case Coordinator is',
      'label_a_b' => 'Case Coordinator is',
      'name_b_a' => 'Case Coordinator',
      'label_b_a' => 'Case Coordinator',
      'description' => 'Case Coordinator',
      'contact_type_a' => 'Individual',
      'contact_type_b' => 'Individual',
      'is_reserved' => 0,
    ],
    [
      'name_a_b' => 'Supervised by',
      'label_a_b' => 'Supervised by',
      'name_b_a' => 'Supervisor',
      'label_b_a' => 'Supervisor',
      'description' => 'Immediate workplace supervisor',
      'contact_type_a' => 'Individual',
      'contact_type_b' => 'Individual',
      'is_reserved' => 0,
    ],
  ]);
